/*
 * Created on 27/08/2008
 */
package org.cyrano.editor.listeners;

import java.util.EventListener;

import javax.swing.event.EventListenerList;

/**
 * @author Demián Gutierrez
 */
public class SelectionListenerProxy {

  protected EventListenerList eventListenerList;

  // --------------------------------------------------------------------------------

  public SelectionListenerProxy(EventListenerList eventListenerList) {
    this.eventListenerList = eventListenerList;
  }

  // --------------------------------------------------------------------------------

  public void addSelectionListener(SelectionListener listener) {
    eventListenerList.add(SelectionListener.class, listener);
  }

  public void delSelectionListener(SelectionListener listener) {
    eventListenerList.remove(SelectionListener.class, listener);
  }

  // --------------------------------------------------------------------------------

  public EventListener[] getSelectionListener() {
    return eventListenerList.getListeners(SelectionListener.class);
  }

  // --------------------------------------------------------------------------------

  public void fireSelectionEvent(SelectionEvent evt) {
    EventListener[] eventListeners = getSelectionListener();

    for (int i = 0; i < eventListeners.length; i++) {
      SelectionListener listener = (SelectionListener) eventListeners[i];
      listener.selectionChanged(evt);
    }
  }
}
