package org.cyrano.timetable.ui.command;

import java.util.ArrayList;
import java.util.List;

import org.cyrano.editor.listeners.Command;
import org.cyrano.timetable.ui.model.timetable.Cour;
import org.cyrano.timetable.ui.model.timetable.Prof;
import org.cyrano.timetable.ui.model.timetable.Sect;
import org.cyrano.timetable.ui.model.timetable.Sems;

public class ClearProfFromSectCommand implements Command {

  private final List<Sect> sectList = new ArrayList<Sect>();

  private final Prof prof;

  // --------------------------------------------------------------------------------

  public ClearProfFromSectCommand(Prof prof) {
    this.prof = prof;

    for (Sems sems : prof.getRoot().getSemsList().getChildrenList()) {
      for (Cour cour : sems.getCourList().getChildrenList()) {
        for (Sect sect : cour.getSectList().getChildrenList()) {
          if (sect.getProf() == prof) {
            sectList.add(sect);
          }
        }
      }
    }
  }

  // --------------------------------------------------------------------------------

  @Override
  public void redoCommand() {
    for (Sect sect : sectList) {
      sect.setProf(null);
    }
  }

  // --------------------------------------------------------------------------------

  @Override
  public void undoCommand() {
    for (Sect sect : sectList) {
      sect.setProf(prof);
    }
  }

  // --------------------------------------------------------------------------------

  @Override
  public boolean canExecute() {
    return true;
  }
}
