package org.cyrano.timetable.ui.command;

import org.cyrano.editor.listeners.Command;
import org.cyrano.timetable.ui.model.timetable.Slot;

public class UpdateSlotCommand implements Command {

  private Slot prevSlot;
  private Slot mainSlot;
  private Slot nextSlot;

  public UpdateSlotCommand(Slot prevSlot, Slot mainSlot, Slot nextSlot) {
    this.prevSlot = prevSlot;
    this.mainSlot = mainSlot;
    this.nextSlot = nextSlot;
  }

  @Override
  public void redoCommand() {
    mainSlot.shallowDataCopyFrom(nextSlot);
  }

  @Override
  public void undoCommand() {
    mainSlot.shallowDataCopyFrom(prevSlot);
  }

  @Override
  public boolean canExecute() {
    return true;
  }
}
