package org.cyrano.timetable.ui.edit;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.UIDefaults;
import javax.swing.tree.DefaultTreeCellRenderer;

import org.cyrano.timetable.ui.model.base.BaseModel;
import org.cyrano.timetable.ui.model.base.ColorProvider;

public class ColorTreeCellRenderer extends DefaultTreeCellRenderer {

  @Override
  public Component getTreeCellRendererComponent(JTree tree, Object value,
      boolean selected, boolean expanded, boolean leaf, //
      int row, boolean hasFocus) {

    RootTreeNode timeTableTreeNode = (RootTreeNode) value;

    return getTreeCellRendererComponentFor( //
        (BaseModel) timeTableTreeNode.getUserObject(), selected);
  }

  // --------------------------------------------------------------------------------

  private Component getTreeCellRendererComponentFor( //
      BaseModel baseModel, boolean selected) {

    JPanel ret = new JPanel(new FlowLayout());

    if (baseModel instanceof ColorProvider) {
      ColorProvider colorProvider = (ColorProvider) baseModel;

      JLabel lblColor = new JLabel();
      lblColor.setPreferredSize/**/(new Dimension(14, 14));
      lblColor.setMinimumSize/*  */(new Dimension(14, 14));
      lblColor.setMaximumSize/*  */(new Dimension(14, 14));
      lblColor.setBackground(colorProvider.getBackground());
      lblColor.setOpaque(true);
      ret.add(lblColor);
    }

    ret.add(new JLabel(baseModel.getDisplayName()));

    setBackgroundAndForegroundFor(ret, selected);

    return ret;
  }

  // --------------------------------------------------------------------------------

  private void setBackgroundAndForegroundFor( //
      JComponent component, boolean selected) {
    UIDefaults defaults = javax.swing.UIManager.getDefaults();

    if (selected) {
      component.setBackground(defaults.getColor("Tree.selectionBackground"));
      component.setForeground(defaults.getColor("Tree.selectionForeground"));
      component.setOpaque(true/* */);
    } else {
      component.setBackground(defaults.getColor("Tree.textBackground"/* */));
      component.setForeground(defaults.getColor("Tree.textForeground"/* */));
      component.setOpaque(false/**/);
    }
  }
}
