package org.cyrano.timetable.ui.model.base;

import javax.swing.event.EventListenerList;

public class VisibilityChangeSupport {

  private final EventListenerList eventListenerList;

  // --------------------------------------------------------------------------------

  public VisibilityChangeSupport(EventListenerList eventListenerList) {
    this.eventListenerList = eventListenerList;
  }

  // --------------------------------------------------------------------------------

  public void addVisibilityChangeListener( //
      VisibilityChangeListener visibilityChangeListener) {

    eventListenerList.add( //
        VisibilityChangeListener.class, visibilityChangeListener);
  }

  // --------------------------------------------------------------------------------

  public void delVisibilityChangeListener( //
      VisibilityChangeListener visibilityChangeListener) {

    eventListenerList.remove( //
        VisibilityChangeListener.class, visibilityChangeListener);
  }

  // --------------------------------------------------------------------------------

  public VisibilityChangeListener[] getVisibilityChangeListeners() {
    return eventListenerList.getListeners( //
        VisibilityChangeListener.class);
  }

  // --------------------------------------------------------------------------------

  public final void fireVisibilityChange( //
      VisibilityChangeEvent evt) {

    VisibilityChangeListener[] listeners = //
    getVisibilityChangeListeners();

    for (int i = 0; i < listeners.length; i++) {
      listeners[i].visibilityChanged(evt);
    }
  }
}
