package org.cyrano.timetable.ui.model.hour;

import org.apache.commons.lang.StringUtils;
import org.cyrano.utils.Rect;

public class Hour {

  private final Rect rect = new Rect();

  public final String day;
  public final String beg;
  public final String end;

  // --------------------------------------------------------------------------------

  public int currx;
  public int count;

  // --------------------------------------------------------------------------------

  public Hour( //
      String day, String beg, String end, //
      int x, int y, int w, int h) {

    this.day = day;
    this.beg = beg;
    this.end = end;

    rect.x = x;
    rect.y = y;
    rect.w = w;
    rect.h = h;

    currx = x;
    count = 0;
  }

  // --------------------------------------------------------------------------------

  public Rect getRect() {
    return rect;
  }

  // --------------------------------------------------------------------------------

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((day == null) ? 0 : day.hashCode());
    result = prime * result + ((beg == null) ? 0 : beg.hashCode());
    result = prime * result + ((end == null) ? 0 : end.hashCode());
    return result;
  }

  // --------------------------------------------------------------------------------

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (getClass() != obj.getClass()) {
      return false;
    }

    Hour oth = (Hour) obj;

    if (!StringUtils.equals(oth.day, day)) {
      return false;
    }

    if (!StringUtils.equals(oth.beg, beg)) {
      return false;
    }

    if (!StringUtils.equals(oth.end, end)) {
      return false;
    }

    return true;
  }
}
