package org.cyrano.timetable.ui.model.hour;

import static org.cyrano.utils.ListUtils.*;

import java.util.List;

public class HourBlock {

  public static final String COUNT = "count";
  public static final String CURRX = "currx";

  // --------------------------------------------------------------------------------

  private List<Hour> hourList;

  // --------------------------------------------------------------------------------

  public HourBlock(List<Hour> hourList) {
    if (hourList.isEmpty()) {
      throw new IllegalArgumentException();
    }

    this.hourList = hourList;
  }

  // --------------------------------------------------------------------------------

  public int max(String field) {
    Hour max = null;

    for (Hour cur : hourList) {
      if (max == null) {
        max = cur;
      }

      if (get(cur, field) > get(max, field)) {
        max = cur;
      }
    }

    return get(max, field);
  }

  // --------------------------------------------------------------------------------

  private int get(Hour hour, String field) {
    Class<?> clazz = hour.getClass();

    try {
      return (Integer) clazz.getField(field).get(hour);
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }

  // --------------------------------------------------------------------------------

  public void set(String field, int value) {
    for (Hour cur : hourList) {
      set(cur, field, value);
    }
  }

  // --------------------------------------------------------------------------------

  private void set(Hour hour, String field, int value) {
    Class<?> clazz = hour.getClass();

    try {
      clazz.getField(field).set(hour, value);
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }

  // --------------------------------------------------------------------------------

  public Hour getBegHour() {
    return hourList.get(beg(hourList));
  }

  // --------------------------------------------------------------------------------

  public Hour getEndHour() {
    return hourList.get(end(hourList));
  }
}
