package org.cyrano.timetable.ui.model.timetable;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import org.cyrano.timetable.ui.model.base.BaseModel;
import org.cyrano.timetable.ui.model.base.Children;
import org.cyrano.timetable.ui.model.base.ColorProvider;
import org.cyrano.timetable.ui.model.base.ModelChangeEvent;
import org.cyrano.timetable.ui.model.base.ObjectMatcher;
import org.cyrano.timetable.ui.model.base.VisibilityChangeEvent;

public class Prof implements BaseModel, ColorProvider {

  public static final ObjectMatcher<Prof, String> PROF_BY_INIT_MATCHER = //
  new ObjectMatcher<Prof, String>() {
    @Override
    public boolean matches(Prof object, String target) {
      return target.equals(object.getInit());
    }
  };

  // --------------------------------------------------------------------------------

  private Children<Root> rootRef;

  private String init;

  private Color background;

  private boolean visible = true;

  // --------------------------------------------------------------------------------

  public Prof() {
    // Empty
  }

  // --------------------------------------------------------------------------------

  public Children<Root> getRootRef() {
    return rootRef;
  }

  public void setRootRef(Children<Root> rootRef) {
    this.rootRef = rootRef;
  }

  // --------------------------------------------------------------------------------

  public String getInit() {
    return init;
  }

  public void setInit(String init) {
    this.init = init;
  }

  // --------------------------------------------------------------------------------
  // ColorProvider
  // --------------------------------------------------------------------------------

  @Override
  public Color getBackground() {
    return background;
  }

  public void setBackground(Color background) {
    this.background = background;
  }

  // --------------------------------------------------------------------------------
  // BaseModel
  // --------------------------------------------------------------------------------

  @Override
  public Root getRoot() {
    return rootRef != null ? rootRef.getParentRef() : null;
  };

  // --------------------------------------------------------------------------------

  @Override
  public String getDisplayName() {
    return init;
  }

  // --------------------------------------------------------------------------------

  public boolean getVisible() {
    return visible;
  }

  @Override
  public void setVisible(boolean visible) {
    this.visible = visible;
    getRoot().getVisibilityChangeSupport(). //
        fireVisibilityChange(new VisibilityChangeEvent(this));
  }

  // --------------------------------------------------------------------------------

  @Override
  public List<Slot> getAllChildrenSlots() {
    List<Slot> ret = new ArrayList<Slot>();

    List<Slot> allChildrenSlots = //
    rootRef.getParentRef().getAllChildrenSlots();

    for (Slot slot : allChildrenSlots) {
      if (slot.getSectRef().getParentRef().getProf() == this) {
        ret.add(slot);
      }
    }

    return ret;
  }

  // --------------------------------------------------------------------------------

  @Override
  public void shallowDataCopyFrom(BaseModel baseModel) {
    if (!(baseModel instanceof Prof)) {
      throw new IllegalArgumentException();
    }

    Prof from = (Prof) baseModel;

    this.init = from.init;
    this.background = from.background;

    if (getRoot() != null) {
      getRoot().getModelChangeSupport().fireModelChange(new ModelChangeEvent(this, this));
    }
  }
}
