package org.cyrano.utils;

import java.awt.Color;

public class ColorParser {

  public static Color parse(String str) {
    if (!str.startsWith("#")) {
      throw new RuntimeException(str);
    }

    if (str.length() != 7) {
      throw new RuntimeException(str);
    }

    String r = str.substring(1, 3);
    String g = str.substring(3, 5);
    String b = str.substring(5, 7);

    try {
      Color ret = new Color( //
          Integer.parseInt(r, 16), //
          Integer.parseInt(g, 16), //
          Integer.parseInt(b, 16));

      return ret;
    } catch (Exception e) {
      throw new RuntimeException(str);
    }
  }

  // --------------------------------------------------------------------------------

  public static String toString(Color color) {
    StringBuffer strbuf = new StringBuffer("#");

    //@begnf
    strbuf.append(intToColorHex(color.getRed  ()));
    strbuf.append(intToColorHex(color.getGreen()));
    strbuf.append(intToColorHex(color.getBlue ()));
    //@endnf

    return strbuf.toString();
  }

  // --------------------------------------------------------------------------------

  private static String intToColorHex(int c) {
    String ret = Integer.toHexString(c);
    ret = ret.length() == 1 ? "0" + ret : ret;

    if (ret.length() != 2) {
      throw new IllegalStateException();
    }

    return ret;
  }
}
